package com.example.radum.supertrackernative;

import android.view.View;
import android.widget.Button;

import com.google.android.gms.maps.CameraUpdate;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.LatLngBounds;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by radum on 16.4.2018.
 */

public class Controls {
    private MapsActivity owner;
    public Controls(MapsActivity owner){
       this.owner=owner;
    }

    public void addEventListeners(){
        Button btnStart = (Button) owner.findViewById(R.id.start);
        btnStart.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                startTracking();
            }
        });
        Button btnCollection = (Button) owner.findViewById(R.id.collection);
        btnCollection.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                viewCollection();
            }
        });
        Button btnStop = (Button) owner.findViewById(R.id.stop);
        btnStop.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                stopTracking();
            }
        });
        Button btnSave = (Button) owner.findViewById(R.id.save);
        btnSave.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                saveTracking();
            }
        });
        Button btnDelete = (Button) owner.findViewById(R.id.delete);
        btnDelete.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                deleteTracking();
            }
        });
        Button btnLeft = (Button) owner.findViewById(R.id.left);
        btnLeft.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                moveCollectionLeft();
            }
        });
        Button btnRight = (Button) owner.findViewById(R.id.right);
        btnRight.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                moveCollectionRight();
            }
        });
        Button btnBack = (Button) owner.findViewById(R.id.back);
        btnBack.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                exitCollection();
            }
        });
    }


    public void initControls(){
        owner.gScreen=MapsActivity.ScreenType.MAIN;
        owner.gRoute=new ArrayList<LatLng>();

        hideAllControls();
        owner.findViewById(R.id.startTrackingControls).setVisibility(View.VISIBLE);
    }

    public  void hideAllControls(){
        owner.findViewById(R.id.startTrackingControls).setVisibility(View.INVISIBLE);
        owner.findViewById(R.id.stopTrackingControls).setVisibility(View.INVISIBLE);
        owner.findViewById(R.id.publishControls).setVisibility(View.INVISIBLE);
        owner.findViewById(R.id.collectionControls).setVisibility(View.INVISIBLE);
        owner.findViewById(R.id.back).setVisibility(View.INVISIBLE);
    }

    public  void startTracking(){
        owner.gScreen= MapsActivity.ScreenType.TRACKING;
        //
        hideAllControls();
        owner.findViewById(R.id.stopTrackingControls).setVisibility(View.VISIBLE);
    }

    public  void stopTracking(){
        owner.gScreen=MapsActivity.ScreenType.PUBLISHING;
        //
        hideAllControls();
        owner.findViewById(R.id.publishControls).setVisibility(View.VISIBLE);
    }

    public  void saveTracking(){
        if(owner.gRoute.size()>=2){
            owner.gCollection.add(owner.gRoute);
        }

        owner.saveCollection();

        initControls();
    }

    public  void deleteTracking(){
        initControls();
    }
    public  void viewCollection(){
        owner.gScreen=MapsActivity.ScreenType.COLLECTION;
        owner.gCollectionIndex=0;
        hideAllControls();
        owner.findViewById(R.id.collectionControls).setVisibility(View.VISIBLE);
        owner.findViewById(R.id.back).setVisibility(View.VISIBLE);
        showCollectionElement(owner.gCollectionIndex);
    }
    public  void showCollectionElement(int index){
        Button b=owner.findViewById(R.id.routeIndex);

        if(owner.gCollection.size()>0) {
            b.setText((index+1)+"/"+owner.gCollection.size());
            //
            owner.gPolyline.setPoints(owner.gCollection.get(index));
            owner.gPolyline.setVisible(true);

            LatLngBounds.Builder builder = new LatLngBounds.Builder();
            List<LatLng> arr = owner.gPolyline.getPoints();
            for(int i = 0; i < arr.size();i++){
                builder.include(arr.get(i));
            }
            LatLngBounds bounds = builder.build();
            int padding = 40; // offset from edges of the map in pixels
            CameraUpdate cu = CameraUpdateFactory.newLatLngBounds(bounds, padding);
            owner.gMap.animateCamera(cu);
        }else{
            b.setText("Empty");
        }
    }

    public  void exitCollection(){
        initControls();
    }

    public void moveCollectionLeft(){
        if(owner.gCollectionIndex>0){
            owner.gCollectionIndex--;
        }
        showCollectionElement(owner.gCollectionIndex);
    }

    public  void moveCollectionRight(){
        if(owner.gCollectionIndex<owner.gCollection.size()-1){
            owner.gCollectionIndex++;
        }
        showCollectionElement(owner.gCollectionIndex);
    }

}
